
#include "fullSpace.h"

AllGeneralizationDomainSet *AllGeneralizationDomainSet_new()
{
	AllGeneralizationDomainSet *returnValue;

	returnValue = (AllGeneralizationDomainSet *) malloc(sizeof(AllGeneralizationDomainSet));
	memset(returnValue, 0, sizeof(AllGeneralizationDomainSet));

	return returnValue;
}

GeneralizationDomainSet *GeneralizationDomainSet_new()
{
	GeneralizationDomainSet *returnValue;

	returnValue = (GeneralizationDomainSet *) malloc(sizeof(GeneralizationDomainSet));
	memset(returnValue, 0, sizeof(GeneralizationDomainSet));

	return returnValue;
}

GeneralizationDomain *GeneralizationDomain_new()
{
	GeneralizationDomain *returnValue;

	returnValue = (GeneralizationDomain *) malloc(sizeof(GeneralizationDomain));
	memset(returnValue, 0, sizeof(GeneralizationDomain));

	return returnValue;
}

void insertGeneralizationDomain2GeneralizationDomainSet(GeneralizationDomainSet *genDomainSet, int **genLevel)
{
	GeneralizationDomain *domain;
	int noOfDomain;
	
	domain = genDomainSet->domain;
	noOfDomain = genDomainSet->noOfDomain;

	if (noOfDomain == 0)
	{
		domain = (GeneralizationDomain *) malloc(sizeof(GeneralizationDomain));
	}
	else
	{
		domain = (GeneralizationDomain *) realloc(domain, sizeof(GeneralizationDomain)*(noOfDomain+1));
	}

	domain[noOfDomain].isAlpha = 0;
	domain[noOfDomain].genLevel = (*genLevel);

	genDomainSet->noOfDomain++;
	genDomainSet->domain = domain;
}

void free_GeneralizationDomainSet(GeneralizationDomainSet *genDomainSet)
{
	int i;

	for (i = 0; i < genDomainSet->noOfDomain; i++)
	{
		free(genDomainSet->domain[i].genLevel);
	}

	if (genDomainSet->noOfDomain >0)
	{
		free(genDomainSet->domain);
	}

	if (genDomainSet->attrList.noOfAttr > 0)
	{
		free(genDomainSet->attrList.attr);
		free(genDomainSet->hasSubset);
	}
}

void insertGeneralizationDomainSet2AllGeneralizationDomainSet(AllGeneralizationDomainSet *allGenDomainSet, GeneralizationDomainSet *newGenDomainSet)
{
	GeneralizationDomainSet *set;
	int noOfSet;

	set = allGenDomainSet->set;
	noOfSet = allGenDomainSet->noOfSet;

	if (noOfSet == 0)
	{
		set = (GeneralizationDomainSet *) malloc(sizeof(GeneralizationDomainSet));
	}
	else
	{
		set = (GeneralizationDomainSet *) realloc(set, sizeof(GeneralizationDomainSet)*(noOfSet+1));
	}

	memcpy(&(set[noOfSet]), newGenDomainSet, sizeof(GeneralizationDomainSet));

	allGenDomainSet->noOfSet++;
	allGenDomainSet->set = set;
}

void free_AllGeneralizationDomainSet(AllGeneralizationDomainSet *allGenDomainSet)
{
	int i;

	for (i = 0; i < allGenDomainSet->noOfSet; i++)
	{
		free_GeneralizationDomainSet(&(allGenDomainSet->set[i]));
	}
	if (allGenDomainSet->noOfSet > 0)
	{
		free(allGenDomainSet->set);
	}
}

// NULL: not similar
AttributeList *getLargerAttributeList(AttributeList *attrList1, AttributeList *attrList2, int **index1, int **index2)
{
	AttributeList *returnValue;
	int noOfAttr;

	int *list1;
	int *list2;

	int i, j;

	int allDiff, diffNo;

	int noOfSame;

	int *newList;

	int *tempIndex1;
	int *tempIndex2; 

	int isFound;

	//
	noOfAttr = attrList1->noOfAttr;

	list1 = attrList1->attr;
	list2 = attrList2->attr;

	diffNo = -1;
	noOfSame = 0;
	for (i = 0; i < noOfAttr; i++)
	{
		allDiff = 1;
		for (j = 0; j < noOfAttr; j++)
		{
			if (list1[i] == list2[j])
			{
				noOfSame++;
				allDiff = 0;
				break;
			}
		}
		if (allDiff == 1)
		{
			diffNo = list1[i];	
		}
	}

	if (noOfSame == noOfAttr-1)
	{
		returnValue = (AttributeList *) malloc(sizeof(AttributeList));
		memset(returnValue, 0, sizeof(AttributeList));

		returnValue->noOfAttr = noOfAttr+1;
		newList = (int *) malloc(sizeof(int)*(noOfAttr+1));

		// copy the list2 to the newlist
		memcpy(newList, list2, sizeof(int)*noOfAttr);

		// insert diffNo to the new list in the proper position (in ascending order)
		if (diffNo > newList[noOfAttr-1])
		{
			newList[noOfAttr] = diffNo;
		}
		else
		{
			for (i = 0; i < noOfAttr; i++)
			{
				if (diffNo <= newList[i])
				{
					for (j = noOfAttr; j > i; j--)
					{
						newList[j] = newList[j-1];
					}
					newList[i] = diffNo;
					break;
				}
			}
		}

		returnValue->attr = newList;

		// index1 and index2
		tempIndex1 = (int *) malloc(sizeof(int)*(noOfAttr+1));
		tempIndex2 = (int *) malloc(sizeof(int)*(noOfAttr+1));
		memset(tempIndex1, 0, sizeof(int)*(noOfAttr+1));
		memset(tempIndex2, 0, sizeof(int)*(noOfAttr+1));
		for (i = 0; i < noOfAttr+1; i++)
		{
			isFound = 0;
			for (j = 0; j < noOfAttr; j++)
			{
				if (newList[i] == list1[j])
				{
					tempIndex1[i] = j;
					isFound = 1;
					break;
				}
			}
			if (isFound == 0)
			{
				tempIndex1[i] = -1;
			}

			isFound = 0;
			for (j = 0; j < noOfAttr; j++)
			{
				if (newList[i] == list2[j])
				{
					tempIndex2[i] = j;
					isFound = 1;
					break;
				}
			}
			if (isFound == 0)
			{
				tempIndex2[i] = -1;
			}
		}

		(*index1) = tempIndex1;
		(*index2) = tempIndex2;
	}
	else
	{
		returnValue = NULL;

		(*index1) = NULL;
		(*index2) = NULL;
	}


	return returnValue;
}

void generateLargerDomain(GeneralizationDomainSet *finalGenDomainSet, GeneralizationDomainSet *genDomainSet1, GeneralizationDomainSet *genDomainSet2, int *index1, int *index2)
{
	int noOfDomain1, noOfDomain2;
	GeneralizationDomain *domain1;
	GeneralizationDomain *domain2;

	int tempIndex1, tempIndex2;
	int *genLevel1;
	int *genLevel2;

	int isAlpha1, isAlpha2;

	int *newGenLevel;

	int noOfAttr;

	int i, j, k;

	int isSame;

	noOfAttr = finalGenDomainSet->attrList.noOfAttr;
	
	noOfDomain1 = genDomainSet1->noOfDomain;
	domain1 = genDomainSet1->domain;

	noOfDomain2 = genDomainSet2->noOfDomain;
	domain2 = genDomainSet2->domain;

	for (i = 0; i < noOfDomain1; i++)
	{
		for (j = 0; j < noOfDomain2; j++)
		{
			isAlpha1 = domain1[i].isAlpha;
			isAlpha2 = domain2[j].isAlpha;

			// if both are alpha
			if ((isAlpha1 == 1) && (isAlpha2 == 1))
			{

				genLevel1 = domain1[i].genLevel;
				genLevel2 = domain2[j].genLevel;

				isSame = 1;
				for (k = 0; k < noOfAttr; k++)
				{
					tempIndex1 = index1[k];
					tempIndex2 = index2[k];

					if ((tempIndex1 != -1) && (tempIndex2 != -1))
					{
						if (genLevel1[tempIndex1] != genLevel2[tempIndex2])
						{
							isSame = 0;
							break;
						}
					}
				}

				if (isSame == 0)
				{
					// is not the same
					// do nothing
				}
				else
				{
					// is same

					// insert to genDomainSet

					// create gen level
					newGenLevel = (int *) malloc(sizeof(int)*noOfAttr);
					for (k = 0; k < noOfAttr; k++)
					{
						tempIndex1 = index1[k];
						tempIndex2 = index2[k];

						if (tempIndex1 == -1)
						{
							newGenLevel[k] = genLevel2[tempIndex2];
						}
						else if (tempIndex2 == -1)
						{
							newGenLevel[k] = genLevel1[tempIndex1];
						}
						else
						{
							newGenLevel[k] = genLevel1[tempIndex1];	// use one of them (due to equal)
						}
					}
					
					// insert gen level to finalGenDomainSet
					insertGeneralizationDomain2GeneralizationDomainSet(finalGenDomainSet, &newGenLevel);

					
				}
			}
			else
			{
				// do nothing
			}
		}
	}
}


// -1: cant' find
int searchAttrList_AllGeneralizationDomainSet(AllGeneralizationDomainSet *allGenDomainSet, AttributeList *attrList)
{
	int i, j;

	int noOfSet;
	GeneralizationDomainSet *set;

	int noOfAttr;
	int *currAttr;

	int isSame;

	int *checkAttr;

	noOfSet = allGenDomainSet->noOfSet;
	set = allGenDomainSet->set;

	noOfAttr = attrList->noOfAttr;
	currAttr = attrList->attr;
	
	for (i = 0; i < noOfSet; i++)
	{
		checkAttr = set[i].attrList.attr;

		isSame = 1;
		for (j = 0; j < noOfAttr; j++)
		{
			if (currAttr[j] != checkAttr[j])
			{
				isSame = 0;
				break;
			}
		}

		if (isSame == 1)
		{
			return i;
		}
	}

	// cannot find
	return -1;
}

void removeGeneralizationDomain(GeneralizationDomainSet *genDomainSet, int index)
{
	int noOfDomain;
	GeneralizationDomain *domain;

	GeneralizationDomain *newDomain;

	int *removeGenLevel;

	noOfDomain = genDomainSet->noOfDomain;
	domain = genDomainSet->domain;

	if (noOfDomain > 1)
	{
		newDomain = (GeneralizationDomain *) malloc(sizeof(GeneralizationDomain)*(noOfDomain-1));
	}
	else
	{
		newDomain = NULL;
	}

	removeGenLevel = domain[index].genLevel;

	if (index > 0)
	{
		memcpy(newDomain, domain, sizeof(GeneralizationDomain)*index);
	}

	if (index < noOfDomain-1)
	{
		memcpy(&(newDomain[index]), &(domain[index+1]), sizeof(GeneralizationDomain)*(noOfDomain-index-1));
	}

	genDomainSet->noOfDomain--;
	genDomainSet->domain = newDomain;

	free(removeGenLevel);
	free(domain);
}

void removeGeneralizationDomainSet(AllGeneralizationDomainSet *allGenDomainSet, int index)
{
	int noOfSet;
	GeneralizationDomainSet *set;
	GeneralizationDomainSet *newSet;

	GeneralizationDomainSet *removeGenDomainSet;

	noOfSet = allGenDomainSet->noOfSet;
	set = allGenDomainSet->set;

	if (noOfSet > 1)
	{
		newSet = (GeneralizationDomainSet *) malloc(sizeof(GeneralizationDomainSet)*(noOfSet-1));
	}
	else
	{
		newSet = NULL;
	}

	removeGenDomainSet = &(set[index]);
	free_GeneralizationDomainSet(removeGenDomainSet);

	if (index > 0)
	{
		memcpy(newSet, set, sizeof(GeneralizationDomainSet)*index);
	}

	if (index < noOfSet-1)
	{
		memcpy(&(newSet[index]), &(set[index+1]), sizeof(GeneralizationDomainSet)*(noOfSet-index-1));
	}

	allGenDomainSet->noOfSet--;
	allGenDomainSet->set = newSet;

	free(set);
}

void intersectionTwoGenDomainSet(GeneralizationDomainSet *resultGenDomainSet, GeneralizationDomainSet *newGenDomainSet)
{
	int noOfDomain_res, noOfDomain_new;
	GeneralizationDomain *domain_res;
	GeneralizationDomain *domain_new;
	int *genLevel_res;
	int *genLevel_new;

	int i, j, k;

	int *isExist;

	int noOfAttr;

	int isSame;

	

	noOfDomain_new = newGenDomainSet->noOfDomain;
	domain_new = newGenDomainSet->domain;

	noOfDomain_res = resultGenDomainSet->noOfDomain;
	domain_res = resultGenDomainSet->domain;

	noOfAttr = resultGenDomainSet->attrList.noOfAttr;

	isExist = (int *) malloc(sizeof(int)*noOfDomain_res);
	memset(isExist, 0, sizeof(int)*noOfDomain_res);
	for (i = 0; i < noOfDomain_res; i++)
	{
		genLevel_res = domain_res[i].genLevel;

		for (j = 0; j < noOfDomain_new; j++)
		{
			genLevel_new = domain_new[j].genLevel;

			isSame = 1;
			for (k = 0; k < noOfAttr; k++)
			{
				if (genLevel_res[k] != genLevel_new[k])
				{
					isSame = 0;
					break;
				}
			}

			// same
			if (isSame == 1)
			{
				isExist[i] = 1;
				break;
			}
		}
	} 

	// remove when exist = 0
	for (i = noOfDomain_res-1; i >= 0; i--)
	{
		if (isExist[i] == 0)
		{
			removeGeneralizationDomain(resultGenDomainSet, i);
		}
	}

	free(isExist);
}

AllGeneralizationDomainSet *generateLargerDimension(AllGeneralizationDomainSet *allGenDomainSet)
{
	AllGeneralizationDomainSet *returnValue;
	int noOfSet;
	GeneralizationDomainSet *set;

	AttributeList *largerAttrList;

	GeneralizationDomainSet *genDomainSet;
	GeneralizationDomainSet *prevGenDomainSet;

	int i, j, k;

	int *index1;
	int *index2;

	int searchIndex;

	int noOfLargeAttr;

	int isAll;
	int noOfAttr;
	int *hasSubset;
	GeneralizationDomainSet *oneSet;

	returnValue = AllGeneralizationDomainSet_new();

	noOfSet = allGenDomainSet->noOfSet;
	set = allGenDomainSet->set;

	for (i = 0; i < noOfSet; i++)
	{
		for (j = i+1; j < noOfSet; j++)
		{
			if (i != j)
			{
				//
				largerAttrList = getLargerAttributeList(&(set[i].attrList), &(set[j].attrList), &index1, &index2);
				if (largerAttrList == NULL)
				{
					// not similar
					// do nothing
				}
				else
				{
					// similar dimensions

					searchIndex = searchAttrList_AllGeneralizationDomainSet(returnValue, largerAttrList);

					// check whether created previously
					if (searchIndex != -1)
					{
						// created previously 


						// virtual generat the domain set
						// generate the domain set
						genDomainSet = GeneralizationDomainSet_new();
						memcpy(&(genDomainSet->attrList), largerAttrList, sizeof(AttributeList));

						// for hasSubset
						noOfLargeAttr = largerAttrList->noOfAttr;
						genDomainSet->hasSubset = (int *) malloc(sizeof(int)*noOfLargeAttr);
						memset(genDomainSet->hasSubset, 0, sizeof(int)*noOfLargeAttr);
						for (k = 0; k < noOfLargeAttr; k++)
						{
							if ((index1[k] == -1) || (index2[k] == -1))
							{
								genDomainSet->hasSubset[k] = 1;
							}
						}

						// generate a number of domains and insert into genDomainSet
						generateLargerDomain(genDomainSet, &(set[i]), &(set[j]), index1, index2);

						// **** compare with the previous
						prevGenDomainSet = &(returnValue->set[searchIndex]);

						// update for hasSubset
						for (k = 0; k < noOfLargeAttr; k++)
						{
							if ((index1[k] == -1) || (index2[k] == -1))
							{
								prevGenDomainSet->hasSubset[k] = 1;
							}
						}

						// intersection between prevGenDomainSet and genDomainSet
						intersectionTwoGenDomainSet(prevGenDomainSet, genDomainSet);

						// remove genDomainSet (New one)
						free_GeneralizationDomainSet(genDomainSet);
					}
					else
					{
						// not created previously

						// generate the domain set
						genDomainSet = GeneralizationDomainSet_new();
						memcpy(&(genDomainSet->attrList), largerAttrList, sizeof(AttributeList));

						// for hasSubset
						noOfLargeAttr = largerAttrList->noOfAttr;
						genDomainSet->hasSubset = (int *) malloc(sizeof(int)*noOfLargeAttr);
						memset(genDomainSet->hasSubset, 0, sizeof(int)*noOfLargeAttr);
						for (k = 0; k < noOfLargeAttr; k++)
						{
							if ((index1[k] == -1) || (index2[k] == -1))
							{
								genDomainSet->hasSubset[k] = 1;
							}
						}
						
						// generate a number of domains and insert into genDomainSet
						generateLargerDomain(genDomainSet, &(set[i]), &(set[j]), index1, index2);


						// insert to AllGenDomainSet
						insertGeneralizationDomainSet2AllGeneralizationDomainSet(returnValue, genDomainSet);
					}

					free(largerAttrList);
				}
			}
		}
	}


	// check susbset
	if (returnValue->noOfSet > 0)
	{
		noOfAttr = returnValue->set[0].attrList.noOfAttr;

		for (i = returnValue->noOfSet-1; i >= 0 ; i--)
		{
			oneSet = &(returnValue->set[i]);

			if (oneSet->noOfDomain == 0)
			{
				//
				// need to remove
				removeGeneralizationDomainSet(returnValue, i);
			}
			else
			{
				hasSubset = oneSet->hasSubset;

				isAll = 1;
				for (j = 0; j < noOfAttr; j++)
				{
					if (hasSubset[j] == 0)
					{
						isAll = 0;
						break;
					}
				}

				if (isAll == 0)
				{
					// not all subset has candidates

					// need to remove
					removeGeneralizationDomainSet(returnValue, i);
				}
				else
				{
					// do nothing
				}
			}
		}
	}

	return returnValue;
}

int checkIsParent(GeneralizationDomain *genDomainChild, GeneralizationDomain *genDomainParent, int noOfAttr)
{
	int returnValue;

	int i;

	int *genLevelChild;
	int *genLevelParent;

	genLevelChild = genDomainChild->genLevel;
	genLevelParent = genDomainParent->genLevel;

	returnValue = 1;
	for (i = 0; i < noOfAttr; i++)
	{
		if (genLevelChild[i] > genLevelParent[i])
		{
			returnValue = 0;
			break;
		}
	}

	return returnValue;
}

// mark the behind parents
void markAllParent(GeneralizationDomainSet *genDomainSet, int startIndex)
{
	int noOfDomain;
	GeneralizationDomain *domain;
	GeneralizationDomain *genDomain1;
	GeneralizationDomain *genDomain2;

	int noOfAttr;

	int i;

	int isParent;

	noOfDomain = genDomainSet->noOfDomain;
	domain = genDomainSet->domain;

	noOfAttr = genDomainSet->attrList.noOfAttr;


	genDomain1 = &(domain[startIndex]);

	// skip the previous
	for (i = startIndex+1; i < noOfDomain; i++)
	{
		genDomain2 = &(domain[i]);
		isParent = checkIsParent(genDomain1, genDomain2, noOfAttr);

		// if parent
		if (isParent == 1)
		{
			domain[i].isAlpha = 1;
		}
	}
}

// assume the numbering the level is from 0 to noOfLevel-1
AllGeneralizationDomainSet *generateSingleDimension(int noOfDim, int *noOfLevel)
{
	AllGeneralizationDomainSet *returnValue;
	GeneralizationDomainSet *set;
	GeneralizationDomainSet *oneSet;

	GeneralizationDomain *domain;
	GeneralizationDomain *oneDomain;

	int tempNoOfLevel;

	int i, j;

	returnValue = AllGeneralizationDomainSet_new();

	returnValue->noOfSet = noOfDim;
	set = (GeneralizationDomainSet *) malloc(sizeof(GeneralizationDomainSet)*noOfDim);

	for (i = 0; i < noOfDim; i++)
	{
		tempNoOfLevel = noOfLevel[i];

		oneSet = &(set[i]);

		oneSet->noOfDomain = tempNoOfLevel;

		oneSet->attrList.noOfAttr = 1;
		oneSet->attrList.attr = (int *) malloc(sizeof(int));
		oneSet->attrList.attr[0] = i;

		oneSet->hasSubset = (int *) malloc(sizeof(int));
		memset(oneSet->hasSubset, 0, sizeof(int));

		domain = (GeneralizationDomain *) malloc(sizeof(GeneralizationDomain)*tempNoOfLevel);
		
		for (j = 0; j < tempNoOfLevel; j++)
		{
			oneDomain = &(domain[j]);

			oneDomain->isAlpha = 0;
			oneDomain->genLevel = (int *) malloc(sizeof(int));
			oneDomain->genLevel[0] = j;
		}

		oneSet->domain = domain;
	}

	returnValue->set = set;

	return returnValue;
}

void print_AllGeneralizationDomainSet(FILE *filePtr, AllGeneralizationDomainSet *allGenDomainSet)
{
	int i, j, k;

	int noOfSet;
	GeneralizationDomainSet *set;

	GeneralizationDomainSet *oneSet;

	GeneralizationDomain *domain;

	int noOfAttr;

	AttributeList *attrList;

	GeneralizationDomain *genDomain;

	noOfSet = allGenDomainSet->noOfSet;
	set = allGenDomainSet->set;

	printf("  No. of Set: %d\n", noOfSet);

	for (i = 0; i < noOfSet; i++)
	{
		oneSet = &(set[i]);
		attrList = &(oneSet->attrList);
		noOfAttr = attrList->noOfAttr;

		printf(" %d. Attribute List: ", i);
		for (j = 0; j < noOfAttr; j++)
		{
			printf("%d ", attrList->attr[j]);
		}
		printf("\n");
		printf("      No Of Domain : %d\n", oneSet->noOfDomain);

		domain = oneSet->domain;
		for (j = 0; j < oneSet->noOfDomain; j++)
		{
			genDomain = &(domain[j]);

			printf("      %d. genLevel : ", j);
			for (k = 0; k < noOfAttr; k++)
			{
				printf("%d ", genDomain->genLevel[k]);
			}
			printf("          isAlpha : %d\n", genDomain->isAlpha);
		}
	}
}

int testFullSpace()
{
	FILE *debugFilePtr;

	AllGeneralizationDomainSet *currAllGenDomainSet;
	AllGeneralizationDomainSet *newAllGenDomainSet;

	int noOfDim;
	int *noOfLevel;

	noOfDim = 3;
	noOfLevel = (int *) malloc(sizeof(int)*noOfDim);
	noOfLevel[0] = 3;
	noOfLevel[1] = 2;
	noOfLevel[2] = 2;
	//noOfLevel[3] = 3;

	debugFilePtr = (FILE *) fopen("debug.txt", "w");
	
	// generate the single dimension
	currAllGenDomainSet = generateSingleDimension(noOfDim, noOfLevel);

	printf("Printing currAllGenDomainSet...\n");
	print_AllGeneralizationDomainSet(debugFilePtr, currAllGenDomainSet);

	// do sth
	currAllGenDomainSet->set[0].domain[0].isAlpha = 1;
	currAllGenDomainSet->set[0].domain[1].isAlpha = 1;
	currAllGenDomainSet->set[0].domain[2].isAlpha = 1;

	currAllGenDomainSet->set[1].domain[0].isAlpha = 1;
	currAllGenDomainSet->set[1].domain[1].isAlpha = 1;

	currAllGenDomainSet->set[2].domain[0].isAlpha = 1;
	currAllGenDomainSet->set[2].domain[1].isAlpha = 1;


	// generate larger dimensin
	//AllGeneralizationDomainSet *generateLargerDimension(AllGeneralizationDomainSet *allGenDomainSet);
	newAllGenDomainSet = generateLargerDimension(currAllGenDomainSet);

	//
	currAllGenDomainSet = newAllGenDomainSet;

	// do sth
	currAllGenDomainSet->set[0].domain[0].isAlpha = 1;
	markAllParent(&(currAllGenDomainSet->set[0]), 0);

	currAllGenDomainSet->set[1].domain[1].isAlpha = 1;
	markAllParent(&(currAllGenDomainSet->set[1]), 1);

	currAllGenDomainSet->set[2].domain[2].isAlpha = 1;
	markAllParent(&(currAllGenDomainSet->set[2]), 2);
	 
	
/*	currAllGenDomainSet->set[0].domain[0].isAlpha = 1;
	currAllGenDomainSet->set[0].domain[1].isAlpha = 1;
	currAllGenDomainSet->set[0].domain[2].isAlpha = 1;
	currAllGenDomainSet->set[0].domain[3].isAlpha = 1;
	currAllGenDomainSet->set[0].domain[4].isAlpha = 1;
	currAllGenDomainSet->set[0].domain[5].isAlpha = 1;

	currAllGenDomainSet->set[1].domain[0].isAlpha = 0;
	currAllGenDomainSet->set[1].domain[1].isAlpha = 0;
	currAllGenDomainSet->set[1].domain[2].isAlpha = 1;
	currAllGenDomainSet->set[1].domain[3].isAlpha = 1;
	currAllGenDomainSet->set[1].domain[4].isAlpha = 1;
	currAllGenDomainSet->set[1].domain[5].isAlpha = 1;

	currAllGenDomainSet->set[2].domain[0].isAlpha = 1;
	currAllGenDomainSet->set[2].domain[1].isAlpha = 1;
	currAllGenDomainSet->set[2].domain[2].isAlpha = 1;
	currAllGenDomainSet->set[2].domain[3].isAlpha = 1;
*/
	printf("Printing currAllGenDomainSet...\n");
	print_AllGeneralizationDomainSet(debugFilePtr, currAllGenDomainSet);

	//
	newAllGenDomainSet = generateLargerDimension(currAllGenDomainSet);

	printf("Printing newAllGenDomainSet...\n");
	print_AllGeneralizationDomainSet(debugFilePtr, newAllGenDomainSet);
	
	free_AllGeneralizationDomainSet(newAllGenDomainSet);
	free(newAllGenDomainSet);

	free_AllGeneralizationDomainSet(currAllGenDomainSet);
	free(currAllGenDomainSet);

	free(noOfLevel);

	fclose(debugFilePtr);

	return 0;
}
