
#ifndef GENDOM_H
#define GENDOM_H


#include <stdio.h>
#include <stdlib.h>

#include <string.h>

struct AttributeList_s
{
	int noOfAttr;

	int *attr;
};
typedef struct AttributeList_s AttributeList;



struct GeneralizationDomain_s
{
	int isAlpha;
	int *genLevel;
};
typedef struct GeneralizationDomain_s GeneralizationDomain;

struct GeneralizationDomainSet_s
{
	int noOfDomain;

	GeneralizationDomain *domain;

	int *hasSubset;

	AttributeList attrList;
};
typedef struct GeneralizationDomainSet_s GeneralizationDomainSet;

struct AllGeneralizationDomainSet_s
{
	int noOfSet;

	GeneralizationDomainSet *set;
};
typedef struct AllGeneralizationDomainSet_s AllGeneralizationDomainSet;

AllGeneralizationDomainSet *AllGeneralizationDomainSet_new();
GeneralizationDomainSet *GeneralizationDomainSet_new();
GeneralizationDomain *GeneralizationDomain_new();
void insertGeneralizationDomain2GeneralizationDomainSet(GeneralizationDomainSet *genDomainSet, int **genLevel);
void free_GeneralizationDomainSet(GeneralizationDomainSet *genDomainSet);
void insertGeneralizationDomainSet2AllGeneralizationDomainSet(AllGeneralizationDomainSet *allGenDomainSet, GeneralizationDomainSet *newGenDomainSet);
void free_AllGeneralizationDomainSet(AllGeneralizationDomainSet *allGenDomainSet);

AllGeneralizationDomainSet *generateLargerDimension(AllGeneralizationDomainSet *allGenDomainSet);
void markAllParent(GeneralizationDomainSet *genDomainSet, int startIndex);
AllGeneralizationDomainSet *generateSingleDimension(int noOfDim, int *noOfLevel);

void print_AllGeneralizationDomainSet(FILE *filePtr, AllGeneralizationDomainSet *allGenDomainSet);

#endif
